<?php
/**********************************************************************
 * ProxmoxVPS developed. (26.03.19)
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 **********************************************************************/

namespace ModulesGarden\Servers\ProxmoxCloudVps\App\Http\Actions;


use ModulesGarden\ProxmoxAddon\App\Models\VirtualNetwork;
use ModulesGarden\ProxmoxAddon\App\Models\Whmcs\Hosting;
use ModulesGarden\ProxmoxAddon\App\Services\ApiService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\ProductService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\UserService;
use ModulesGarden\ProxmoxAddon\App\Services\CloudService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\HighAvailabilityClusterService;
use ModulesGarden\ProxmoxAddon\App\Services\Cloud\HostingService;
use ModulesGarden\ProxmoxAddon\Core\Models\ModuleSettings\Model as ModuleSettings;
use ModulesGarden\ProxmoxAddon\App\Enum\Cloud\CustomField;
use ModulesGarden\Servers\ProxmoxCloudVps\App\Helpers\AppParams;
use ModulesGarden\Servers\ProxmoxCloudVps\App\Helpers\ProxmoxAddonValidator;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\App\Controllers\Instances\AddonController;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Traits\WhmcsParams;


class TerminateAccount extends AddonController
{
    use WhmcsParams;
    use ProductService;
    use ApiService;
    use UserService;
    use HostingService;
    /**
     * @var HighAvailabilityClusterService
     */
    private $highAvailabilityClusterService;

    public function __construct()
    {
        $this->highAvailabilityClusterService = new HighAvailabilityClusterService();
    }

    /**
     * @param null $params
     * @return string
     * @todo delete vms
     */
    public function execute($params = null)
    {
        (new AppParams())->initFromParams($params);
        if(!ProxmoxAddonValidator::isInstalled()){
            return ProxmoxAddonValidator::failAsString();
        }
        try
        {
            if (!$this->getWhmcsParamByKey('serviceid'))
            {
                throw new \InvalidArgumentException("The Service Id cannot be empty");
            }
            $serviceId = $this->getWhmcsParamByKey('serviceid');

            //User delete
            if ($this->isUser())
            {
                $this->deleteUser();
            }
            //virtual networks
            VirtualNetwork::ofHostingId($serviceId)->delete();
            //vms
            $cloudService = new CloudService();
            $cloudService->destroy();
            //Reset Custom Fields
            if ($this->getWhmcsCustomField(CustomField::TAG))
            {
                $this->customFieldUpdate(CustomField::TAG, "");
            }
            $this->customFieldUpdate(CustomField::AUTHENTICATION, "");
            //Cache
            ModuleSettings::where('setting', "LIKE", "%{$serviceId}_cacheData%")->delete();
            //ip addresses
            Hosting::where("id", $this->getWhmcsParamByKey('serviceid'))
                ->update(["dedicatedip" => "", "assignedips" => ""]);

            return "success";
        }
        catch (\Exception $ex)
        {
            if (\ModulesGarden\ProxmoxAddon\App\Models\ModuleSettings::isDebug())
            {
                logModuleCall(
                    'ProxmoxCloudVps',
                    __CLASS__,
                    [],
                    null,
                    $ex->getMessage() . " " . $ex->getTraceAsString()
                );
            }
            return $ex->getMessage();
        }
    }
}